# 本地分析

## 使用场景

- 希望在本地随时分析。

- 如果公共机器无法满足编译环境的情况，复用本地编译环境。

- 如果对代码安全有要求也推荐使用本地分析。

## 前置步骤

本地具备客户端。

如果是开源版客户端，需要配置相关环境和依赖，可查阅[开源版客户端使用说明](配置说明.md#开源版客户端使用说明)。

## 分析配置

### 配置客户端 `config.ini` 文件

将 `<Server IP地址>` 替换成实际的serve ip（可包含端口号）

### 配置客户端 `codedog.ini` 文件

- `token`，必填项。从TCA前端页面中获取，前往 **个人中心-个人令牌-复制Token**

- `org_sid`，团队编号，必填项。可以从TCA前端项目页面URL获取。

- `team_name`，项目名称，必填项。可以从TCA前端项目页面URL获取。

  ```bash
  # 如
  http://{域名}/t/{org_sid}/p/{team_name}/profile
  ```

- `source_dir`，本地代码目录路径，必填项。绝对路径。

- 其他参数
  
  按需填写其他可选项，也可以不填，按默认配置执行

## 启动代码分析

### 源码下启动分析

- 进入到`client`目录下

- 执行命令：`python3 codepuppy.py localscan`

### docker下启动分析

#### 直接使用docker运行

- 在client目录下，执行以下命令：
- (注意：按照实际情况填写`SOURCE_DIR`环境变量值)

```bash
export SOURCE_DIR=需要扫描的代码目录绝对路径
docker run -it --rm  -v $PWD:/workspace/client -v $SOURCE_DIR:/workspace/src  --name tca-client tca-client
```

#### 使用docker内bash终端运行

- 通过以下方式，进入容器内的bash终端后，通过命令行启动client代码：
- 在client目录下，执行以下命令：
- (注意：按照实际情况填写`SOURCE_DIR`环境变量值)

```bash
export SOURCE_DIR=需要扫描的代码目录绝对路径
docker run -it --rm  -v $PWD:/workspace/client -v $SOURCE_DIR:/workspace/src  --name tca-client tca-client bash
# 进入容器内终端，通过命令行执行扫描
python3 codepuppy.py localscan
```
